local Template = require "oil.dtests.Template"
local template = Template{"Client"} -- master process name

Server = [=====================================================================[
orb = oil.dtests.init{ port = 2809 }
if oil.dtests.flavor.corba then
	iface = orb:loadidl "interface Terminator { void shutdown(); void idle(); };"
end
orb:newservant{
	__objkey = "object",
	__type = iface,
	idle = function() oil.sleep(1) end,
	shutdown = function() orb:shutdown() end,
}
--[Server]=====================================================================]

Caller = [=====================================================================[
orb = oil.dtests.init()
obj = oil.dtests.resolve("Server", 2809, "object")
obj:idle()
--[Caller]=====================================================================]

Client = [=====================================================================[
checks = oil.dtests.checks

oil.sleep(3)
orb = oil.dtests.init()
obj = oil.dtests.resolve("Server", 2809, "object")

obj:shutdown()
oil.sleep(1)

if oil.dtests.flavor.corba then
	corba = orb
else
	corba = oil.init()
end
server = corba:newproxy(os.getenv("DTEST_HELPER")):getprocess("Server")
assert(server == nil)

if oil.dtests.flavor.corba then
	ok, ex = pcall(obj._non_existent, obj)
	assert(ok == false)
	checks.assert(ex, checks.like{
		_repid = "IDL:omg.org/CORBA/TRANSIENT:1.0",
		completed = "COMPLETED_NO",
		minor = 2,
		error = "badconnect",
		errmsg = "connection refused",
	})
else
	corba:shutdown()
	ok, ex = pcall(obj.idle, obj)
	assert(ok == false)
	checks.assert(ex, checks.like{
		errmsg = "connection refused",
		error = "badconnect",
	})
end

orb:shutdown()
--[Client]=====================================================================]

return template:newsuite{ cooperative = true }
